import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { BehaviorSubject, Observable } from 'rxjs';
import { Router } from '@angular/router';
import * as sha512 from 'js-sha512';

// import * as config from '@assets/config.json';

import { User } from '@app/core/model';
import { StorageService } from '@app/core/services/storage/storage.service';
import { LogService } from '@app/core/services/log/log.service';

@Injectable( { providedIn: 'root' } )
export class AuthService {

  public currentUser: Observable<User>;
  // public emailRegex = new RegExp(  );
  private currentUserSubject: BehaviorSubject<User>;

  constructor( private http: HttpClient, private router: Router, private stor: StorageService, private looger: LogService ) {
    this.currentUserSubject = new BehaviorSubject<User>( stor.getLocal( 'user' ) as User );
    this.currentUser = this.currentUserSubject.asObservable();
  }

  public get currentUserValue(): User {
    if ( this.currentUserSubject.value && this.currentUserSubject.value.timeGetToken + 60 * 60 * 1000 < new Date().getTime() ) {
      const data = new FormData();

      data.append( 'auth_token', this.currentUserSubject.value.token );
      // this.http.post<any>( environment.baseUrl + config.url.upauth, data ).subscribe( ( res ) => {
      //   if ( res.statusCode !== 200 ) {
      //     this.logout();
      //   } else {
      //     this.currentUserSubject.value.timeGetToken = new Date().getTime();
      //     this.stor.setLocal( 'user', this.currentUserSubject.value );
      //   }
      // } );
    }
    return this.currentUserSubject.value;
  }

  public login( username: string, password: string ): any {
    const data: FormData = new FormData();

    data.append( 'email', username );
    data.append( 'password', sha512.sha512( password ) );

    // return this.http.post<any>( environment.baseUrl + config.url.auth, data )
    //   .pipe( map( result => {
    //     let user = new User();
    //
    //     this.looger.logInfo( result );
    //     // login successful if there's a jwt token in the response
    //     if ( result && result.body && result.statusCode === 200 ) {
    //
    //       user.token = result.body;
    //       user.timeGetToken = new Date().getTime();
    //
    //       // store user details and jwt token in local storage to keep user logged in between page refreshes
    //       this.stor.setLocal( 'user', user );
    //       this.currentUserSubject.next( user );
    //     } else {
    //       user = result.statusCode;
    //     }
    //
    //     return user;
    //   } ) );
  }

  public logout(): void {
    // remove user from local storage to log user out
    this.stor.setLocal( 'user' );
    this.currentUserSubject.next( null );
    this.router.navigate( [ '/login' ] );
  }

  public createAccount( email: string, password: string, repeat: string ): any {
    // const data: FormData = new FormData();

    // if ( password === repeat && this.emailRegex.test( email ) ) {
    //   data.append( 'email', email );
    //   data.append( 'password', sha512.sha512( password ) );

      // return this.http.post( environment.baseUrl + config.url.register, data );
    // }

    return null;
  }

}
